maint: more files excluded in 'update-copyright'
[automake.git] / syntax-checks.mk
blob9a8a7e7018972d311a905e23258a3817e0a87695
1 # Maintainer checks for Automake. Requires GNU make.
3 # Copyright (C) 2012 Free Software Foundation, Inc.
5 # This program is free software; you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation; either version 2, or (at your option)
8 # any later version.
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13 # GNU General Public License for more details.
15 # You should have received a copy of the GNU General Public License
16 # along with this program. If not, see <http://www.gnu.org/licenses/>.
18 # We also have to take into account VPATH builds (where some generated
19 # tests might be in '$(builddir)' rather than in '$(srcdir)'), TAP-based
20 # tests script (which have a '.tap' extension) and helper scripts used
21 # by other test cases (which have a '.sh' extension).
22 xtests := $(shell \
23 if test $(srcdir) = .; then \
24 dirs=.; \
25 else \
26 dirs='$(srcdir) .'; \
27 fi; \
28 for d in $$dirs; do \
29 for s in tap sh; do \
30 ls $$d/t/*.$$s $$d/t/ax/*.$$s 2>/dev/null; \
31 done; \
32 done | sort)
34 xdefs = \
35 $(srcdir)/t/ax/am-test-lib.sh \
36 $(srcdir)/t/ax/test-lib.sh \
37 $(srcdir)/t/ax/test-defs.in \
38 $(srcdir)/defs
40 ams := $(shell find $(srcdir) -name '*.dir' -prune -o -name '*.am' -print)
42 # Some simple checks, and then ordinary check. These are only really
43 # guaranteed to work on my machine.
44 syntax_check_rules = \
45 $(sc_tests_plain_check_rules) \
46 sc_diff_automake \
47 sc_diff_aclocal \
48 sc_no_brace_variable_expansions \
49 sc_rm_minus_f \
50 sc_no_for_variable_in_macro \
51 sc_mkinstalldirs \
52 sc_pre_normal_post_install_uninstall \
53 sc_perl_no_undef \
54 sc_perl_no_split_regex_space \
55 sc_cd_in_backquotes \
56 sc_cd_relative_dir \
57 sc_perl_at_uscore_in_scalar_context \
58 sc_perl_local \
59 sc_AMDEP_TRUE_in_automake_in \
60 sc_tests_make_without_am_makeflags \
61 sc_tests_obsolete_variables \
62 sc_tests_here_document_format \
63 sc_tests_command_subst \
64 sc_tests_Exit_not_exit \
65 sc_tests_automake_fails \
66 sc_tests_required_after_defs \
67 sc_tests_overriding_macros_on_cmdline \
68 sc_tests_plain_sleep \
69 sc_tests_ls_t \
70 sc_tests_executable \
71 sc_m4_am_plain_egrep_fgrep \
72 sc_tests_no_configure_in \
73 sc_tests_PATH_SEPARATOR \
74 sc_tests_logs_duplicate_prefixes \
75 sc_tests_makefile_variable_order \
76 sc_perl_at_substs \
77 sc_unquoted_DESTDIR \
78 sc_tabs_in_texi \
79 sc_at_in_texi
81 ## These check avoids accidental configure substitutions in the source.
82 ## There are exactly 8 lines that should be modified from automake.in to
83 ## automake, and 9 lines that should be modified from aclocal.in to
84 ## aclocal.
85 automake_diff_no = 8
86 aclocal_diff_no = 9
87 sc_diff_automake sc_diff_aclocal: sc_diff_% :
88 @set +e; tmp=$*-diffs.tmp; \
89 diff -u $(srcdir)/$*.in $* > $$tmp; test $$? -eq 1 || exit 1; \
90 added=`grep -v '^+++ ' $$tmp | grep -c '^+'` || exit 1; \
91 removed=`grep -v '^--- ' $$tmp | grep -c '^-'` || exit 1; \
92 test $$added,$$removed = $($*_diff_no),$($*_diff_no) \
93 || { \
94 echo "Found unexpected diffs between $*.in and $*"; \
95 echo "Lines added: $$added" ; \
96 echo "Lines removed: $$removed"; \
97 cat $$tmp >&2; \
98 exit 1; \
99 } >&1; \
100 rm -f $$tmp
102 ## Expect no instances of '${...}'. However, $${...} is ok, since that
103 ## is a shell construct, not a Makefile construct.
104 sc_no_brace_variable_expansions:
105 @if grep -v '^ *#' $(ams) | grep -F '$${' | grep -F -v '$$$$'; then \
106 echo "Found too many uses of '\$${' in the lines above." 1>&2; \
107 exit 1; \
108 else :; fi
110 ## Make sure 'rm' is called with '-f'.
111 sc_rm_minus_f:
112 @if grep -v '^#' $(ams) $(xtests) \
113 | grep -vE '/(spy-rm\.tap|subobj-clean.*-pr10697\.sh):' \
114 | grep -E '\<rm ([^-]|\-[^f ]*\>)'; \
115 then \
116 echo "Suspicious 'rm' invocation." 1>&2; \
117 exit 1; \
118 else :; fi
120 ## Never use something like "for file in $(FILES)", this doesn't work
121 ## if FILES is empty or if it contains shell meta characters (e.g. $ is
122 ## commonly used in Java filenames).
123 sc_no_for_variable_in_macro:
124 @if grep 'for .* in \$$(' $(ams) | grep -v '/Makefile\.am:'; then \
125 echo 'Use "list=$$(mumble); for var in $$$$list".' 1>&2 ; \
126 exit 1; \
127 else :; fi
129 ## Make sure all invocations of mkinstalldirs are correct.
130 sc_mkinstalldirs:
131 @if grep -n 'mkinstalldirs' $(ams) \
132 | grep -F -v '$$(mkinstalldirs)' \
133 | grep -v '^\./Makefile.am:[0-9][0-9]*: *lib/mkinstalldirs \\$$'; \
134 then \
135 echo "Found incorrect use of mkinstalldirs in the lines above" 1>&2; \
136 exit 1; \
137 else :; fi
139 ## Make sure all calls to PRE/NORMAL/POST_INSTALL/UNINSTALL
140 sc_pre_normal_post_install_uninstall:
141 @if grep -E -n '\((PRE|NORMAL|POST)_(|UN)INSTALL\)' $(ams) | \
142 grep -v ':##' | grep -v ': @\$$('; then \
143 echo "Found incorrect use of PRE/NORMAL/POST_INSTALL/UNINSTALL in the lines above" 1>&2; \
144 exit 1; \
145 else :; fi
147 ## We never want to use "undef", only "delete", but for $/.
148 sc_perl_no_undef:
149 @if grep -n -w 'undef ' $(srcdir)/automake.in | \
150 grep -F -v 'undef $$/'; then \
151 echo "Found undef in automake.in; use delete instead" 1>&2; \
152 exit 1; \
155 ## We never want split (/ /,...), only split (' ', ...).
156 sc_perl_no_split_regex_space:
157 @if grep -n 'split (/ /' $(srcdir)/automake.in; then \
158 echo "Found bad split in the lines above." 1>&2; \
159 exit 1; \
162 ## Look for cd within backquotes
163 sc_cd_in_backquotes:
164 @if grep -n '^[^#]*` *cd ' $(srcdir)/automake.in $(ams); then \
165 echo "Consider using \$$(am__cd) in the lines above." 1>&2; \
166 exit 1; \
169 ## Look for cd to a relative directory (may be influenced by CDPATH).
170 ## Skip some known directories that are OK.
171 sc_cd_relative_dir:
172 @if grep -n '^[^#]*cd ' $(srcdir)/automake.in $(ams) | \
173 grep -v 'echo.*cd ' | \
174 grep -v 'am__cd =' | \
175 grep -v '^[^#]*cd [./]' | \
176 grep -v '^[^#]*cd \$$(top_builddir)' | \
177 grep -v '^[^#]*cd "\$$\$$am__cwd' | \
178 grep -v '^[^#]*cd \$$(abs' | \
179 grep -v '^[^#]*cd "\$$(DESTDIR)'; then \
180 echo "Consider using \$$(am__cd) in the lines above." 1>&2; \
181 exit 1; \
184 ## Using @_ in a scalar context is most probably a programming error.
185 sc_perl_at_uscore_in_scalar_context:
186 @if grep -Hn '[^@_A-Za-z0-9][_A-Za-z0-9]*[^) ] *= *@_' $(srcdir)/automake.in; then \
187 echo "Using @_ in a scalar context in the lines above." 1>&2; \
188 exit 1; \
191 ## Allow only few variables to be localized in Automake.
192 sc_perl_local:
193 @if egrep -v '^[ \t]*local \$$[_~]( *=|;)' $(srcdir)/automake.in | \
194 grep '^[ \t]*local [^*]'; then \
195 echo "Please avoid 'local'." 1>&2; \
196 exit 1; \
199 ## Don't let AMDEP_TRUE substitution appear in automake.in.
200 sc_AMDEP_TRUE_in_automake_in:
201 @if grep '@AMDEP''_TRUE@' $(srcdir)/automake.in; then \
202 echo "Don't put AMDEP_TRUE substitution in automake.in" 1>&2; \
203 exit 1; \
206 ## Recursive make invocations should always pass $(AM_MAKEFLAGS)
207 ## to $(MAKE), for portability to non-GNU make.
208 sc_tests_make_without_am_makeflags:
209 @if grep '^[^#].*(MAKE) ' $(ams) $(srcdir)/automake.in \
210 | grep -v 'AM_MAKEFLAGS' \
211 | grep -v '/am/header-vars\.am:.*am--echo.*| $$(MAKE) -f *-'; \
212 then \
213 echo 'Use $$(MAKE) $$(AM_MAKEFLAGS).' 1>&2; \
214 exit 1; \
217 ## Look out for some obsolete variables.
218 sc_tests_obsolete_variables:
219 @vars=" \
220 using_tap \
221 am_using_tap \
222 test_prefer_config_shell \
223 original_AUTOMAKE \
224 original_ACLOCAL \
225 parallel_tests \
226 am_parallel_tests \
227 "; \
228 seen=""; \
229 for v in $$vars; do \
230 if grep -E "\b$$v\b" $(xtests) $(xdefs); then \
231 seen="$$seen $$v"; \
232 fi; \
233 done; \
234 if test -n "$$seen"; then \
235 for v in $$seen; do \
236 case $$v in \
237 parallel_tests|am_parallel_tests) v2=am_serial_tests;; \
238 *) v2=am_$$v;; \
239 esac; \
240 echo "Variable '$$v' is obsolete, use '$$v2' instead." 1>&2; \
241 done; \
242 exit 1; \
243 else :; fi
245 ## Tests should never call some programs directly, but only through the
246 ## corresponding variable (e.g., '$MAKE', not 'make'). This will allow
247 ## the programs to be overridden at configure time (for less brittleness)
248 ## or by the user at make time (to allow better testsuite coverage).
249 sc_tests_plain_check_rules = \
250 sc_tests_plain_egrep \
251 sc_tests_plain_fgrep \
252 sc_tests_plain_make \
253 sc_tests_plain_perl \
254 sc_tests_plain_automake \
255 sc_tests_plain_aclocal \
256 sc_tests_plain_autoconf \
257 sc_tests_plain_autoupdate \
258 sc_tests_plain_autom4te \
259 sc_tests_plain_autoheader \
260 sc_tests_plain_autoreconf
262 toupper = $(shell echo $(1) | LC_ALL=C tr '[a-z]' '[A-Z]')
264 $(sc_tests_plain_check_rules): sc_tests_plain_% :
265 @# The leading ':' in the grep below is what is printed by the
266 @# preceding 'grep -v' after the file name.
267 @# It works here as a poor man's substitute for beginning-of-line
268 @# marker.
269 @if grep -v '^[ ]*#' $(xtests) \
270 | $(EGREP) '(:|\bif|\bnot|[;!{\|\(]|&&|\|\|)[ ]*?$*\b'; \
271 then \
272 echo 'Do not run "$*" in the above tests.' \
273 'Use "$$$(call toupper,$*)" instead.' 1>&2; \
274 exit 1; \
277 ## Tests should only use END and EOF for here documents
278 ## (so that the next test is effective).
279 sc_tests_here_document_format:
280 @if grep '<<' $(xtests) | grep -Ev '\b(END|EOF)\b|\bcout <<'; then \
281 echo 'Use here documents with "END" and "EOF" only, for greppability.' 1>&2; \
282 exit 1; \
285 ## Our test case should use the $(...) POSIX form for command substitution,
286 ## rather than the older `...` form.
287 ## The point of ignoring text on here-documents is that we want to exempt
288 ## Makefile.am rules, configure.ac code and helper shell script created and
289 ## used by out shell scripts, because Autoconf (as of version 2.69) does not
290 ## yet ensure that $CONFIG_SHELL will be set to a proper POSIX shell.
291 sc_tests_command_subst:
292 @found=false; \
293 scan () { \
294 sed -n -e '/^#/d' \
295 -e '/<<.*END/,/^END/b' -e '/<<.*EOF/,/^EOF/b' \
296 -e 's/\\`/\\{backtick}/' \
297 -e "s/[^\\]'\([^']*\`[^']*\)*'/'{quoted-text}'/g" \
298 -e '/`/p' $$*; \
299 }; \
300 for file in $(xtests); do \
301 res=`scan $$file`; \
302 if test -n "$$res"; then \
303 echo "$$file:$$res"; \
304 found=true; \
305 fi; \
306 done; \
307 if $$found; then \
308 echo 'Use $$(...), not `...`, for command substitutions.' >&2; \
309 exit 1; \
312 ## Tests should no more call 'Exit', just 'exit'. That's because we
313 ## now have in place a better workaround to ensure the exit status is
314 ## transported correctly across the exit trap.
315 sc_tests_Exit_not_exit:
316 @if grep 'Exit' $(xtests) $(xdefs) | grep -Ev '^[^:]+: *#' | grep .; then \
317 echo "Use 'exit', not 'Exit'; it's obsolete now." 1>&2; \
318 exit 1; \
321 ## Use AUTOMAKE_fails when appropriate
322 sc_tests_automake_fails:
323 @if grep -v '^#' $(xtests) | grep '\$$AUTOMAKE.*&&.*exit'; then \
324 echo 'Use AUTOMAKE_fails + grep to catch automake failures in the above tests.' 1>&2; \
325 exit 1; \
328 ## Setting 'required' after sourcing './defs' is a bug.
329 sc_tests_required_after_defs:
330 @for file in $(xtests); do \
331 if out=`sed -n '/defs/,$${/required=/p;}' $$file`; test -n "$$out"; then \
332 echo 'Do not set "required" after sourcing "defs" in '"$$file: $$out" 1>&2; \
333 exit 1; \
334 fi; \
335 done
337 ## Overriding a Makefile macro on the command line is not portable when
338 ## recursive targets are used. Better use an envvar. SHELL is an
339 ## exception, POSIX says it can't come from the environment. V, DESTDIR,
340 ## DISTCHECK_CONFIGURE_FLAGS and DISABLE_HARD_ERRORS are exceptions, too,
341 ## as package authors are urged not to initialize them anywhere.
342 ## Finally, 'exp' is used by some ad-hoc checks, where we ensure it's
343 ## ok to override it from the command line.
344 sc_tests_overriding_macros_on_cmdline:
345 @if grep -E '\$$MAKE .*(SHELL=.*=|=.*SHELL=)' $(xtests); then \
346 echo 'Rewrite "$$MAKE foo=bar SHELL=$$SHELL" as "foo=bar $$MAKE -e SHELL=$$SHELL"' 1>&2; \
347 echo ' in the above lines, it is more portable.' 1>&2; \
348 exit 1; \
350 # The first s/// tries to account for usages like "$MAKE || st=$?".
351 # 'DISTCHECK_CONFIGURE_FLAGS' and 'exp' are allowed to contain whitespace in
352 # their definitions, hence the more complex last three substitutions below.
353 # Also, the 'make-dryrun.sh' is whitelisted, since there we need to
354 # override variables from the command line in order to cover the expected
355 # code paths.
356 @tests=`for t in $(xtests); do \
357 case $$t in */make-dryrun.sh);; *) echo $$t;; esac; \
358 done`; \
359 if sed -e 's/ || .*//' -e 's/ && .*//' \
360 -e 's/ DESTDIR=[^ ]*/ /' -e 's/ SHELL=[^ ]*/ /' \
361 -e 's/ V=[^ ]*/ /' -e 's/ DISABLE_HARD_ERRORS=[^ ]*/ /' \
362 -e "s/ DISTCHECK_CONFIGURE_FLAGS='[^']*'/ /" \
363 -e 's/ DISTCHECK_CONFIGURE_FLAGS="[^"]*"/ /' \
364 -e 's/ DISTCHECK_CONFIGURE_FLAGS=[^ ]/ /' \
365 -e "s/ exp='[^']*'/ /" \
366 -e 's/ exp="[^"]*"/ /' \
367 -e 's/ exp=[^ ]/ /' \
368 $$tests | grep '\$$MAKE .*='; then \
369 echo 'Rewrite "$$MAKE foo=bar" as "foo=bar $$MAKE -e" in the above lines,' 1>&2; \
370 echo 'it is more portable.' 1>&2; \
371 exit 1; \
373 @if grep 'SHELL=.*\$$MAKE' $(xtests); then \
374 echo '$$MAKE ignores the SHELL envvar, use "$$MAKE SHELL=$$SHELL" in' 1>&2; \
375 echo 'the above lines.' 1>&2; \
376 exit 1; \
379 ## Prefer use of our 'is_newest' auxiliary script over the more hacky
380 ## idiom "test $(ls -1t new old | sed 1q) = new", which is both more
381 ## cumbersome and more fragile.
382 sc_tests_ls_t:
383 @if LC_ALL=C grep -E '\bls(\s+-[a-zA-Z0-9]+)*\s+-[a-zA-Z0-9]*t' \
384 $(xtests); then \
385 echo "Use 'is_newest' rather than hacks based on 'ls -t'" 1>&2; \
386 exit 1; \
389 ## Test scripts must be executable.
390 sc_tests_executable:
391 @st=0; \
392 for f in $(xtests); do \
393 case $$f in \
394 t/ax/*|./t/ax/*|$(srcdir)/t/ax/*);; \
395 *) test -x $$f || { echo "$$f: not executable" >&2; st=1; }; \
396 esac; \
397 done; \
398 test $$st -eq 0 || echo '$@: some test scripts are not executable' >&2; \
399 exit $$st;
402 ## Never use 'sleep 1' to create files with different timestamps.
403 ## Use '$sleep' instead. Some filesystems (e.g., Windows) have only
404 ## a 2sec resolution.
405 sc_tests_plain_sleep:
406 @if grep -E '\bsleep +[12345]\b' $(xtests); then \
407 echo 'Do not use "sleep x" in the above tests. Use "$$sleep" instead.' 1>&2; \
408 exit 1; \
411 ## fgrep and egrep are not required by POSIX.
412 sc_m4_am_plain_egrep_fgrep:
413 @if grep -E '\b[ef]grep\b' $(ams) $(srcdir)/m4/*.m4; then \
414 echo 'Do not use egrep or fgrep in the above files,' \
415 'they are not portable.' 1>&2; \
416 exit 1; \
419 ## Prefer 'configure.ac' over the obsolescent 'configure.in' as the name
420 ## for configure input files in our testsuite. The latter has been
421 ## deprecated for several years (at least since autoconf 2.50).
422 sc_tests_no_configure_in:
423 @if grep -E '\bconfigure\\*\.in\b' $(xtests) $(xdefs) \
424 | grep -Ev '/backcompat.*\.(sh|tap):' \
425 | grep -Ev '/autodist-configure-no-subdir\.sh:' \
426 | grep -Ev '/(configure|help)\.sh:' \
427 | grep .; \
428 then \
429 echo "Use 'configure.ac', not 'configure.in', as the name" >&2; \
430 echo "for configure input files in the test cases above." >&2; \
431 exit 1; \
434 ## Rule to ensure that the testsuite has been run before. We don't depend
435 ## on 'check' here, because that would be very wasteful in the common case.
436 ## We could run "make check RECHECK_LOGS=" and avoid toplevel races with
437 ## AM_RECURSIVE_TARGETS. Suggest keeping test directories around for
438 ## greppability of the Makefile.in files.
439 sc_ensure_testsuite_has_run:
440 @if test ! -f '$(TEST_SUITE_LOG)'; then \
441 echo 'Run "env keep_testdirs=yes make check" before' \
442 'running "make maintainer-check"' >&2; \
443 exit 1; \
445 .PHONY: sc_ensure_testsuite_has_run
447 ## Ensure our warning and error messages do not contain duplicate 'warning:' prefixes.
448 ## This test actually depends on the testsuite having been run before.
449 sc_tests_logs_duplicate_prefixes: sc_ensure_testsuite_has_run
450 @if grep -E '(warning|error):.*(warning|error):' t/*.log; then \
451 echo 'Duplicate warning/error message prefixes seen in above tests.' >&2; \
452 exit 1; \
455 ## Ensure variables are listed before rules in Makefile.in files we generate.
456 sc_tests_makefile_variable_order: sc_ensure_testsuite_has_run
457 @st=0; \
458 for file in `find t -name Makefile.in -print`; do \
459 latevars=`sed -n \
460 -e :x -e 's/#.*//' \
461 -e '/\\\\$$/{' -e N -e 'b x' -e '}' \
462 -e '# Literal TAB.' \
463 -e '1,/^ /d' \
464 -e '# Allow @ so we match conditionals.' \
465 -e '/^ *[a-zA-Z_@]\{1,\} *=/p' $$file`; \
466 if test -n "$$latevars"; then \
467 echo "Variables are expanded too late in $$file:" >&2; \
468 echo "$$latevars" | sed 's/^/ /' >&2; \
469 st=1; \
470 fi; \
471 done; \
472 test $$st -eq 0 || { \
473 echo 'Ensure variables are expanded before rules' >&2; \
474 exit 1; \
477 ## Using ':' as a PATH separator is not portable.
478 sc_tests_PATH_SEPARATOR:
479 @if grep -E '\bPATH=.*:.*' $(xtests) ; then \
480 echo "Use '\$$PATH_SEPARATOR', not ':', in PATH definitions" \
481 "above." 1>&2; \
482 exit 1; \
485 ## Try to make sure all @...@ substitutions are covered by our
486 ## substitution rule.
487 sc_perl_at_substs:
488 @if test `grep -E '^[^#]*@[A-Za-z_0-9]+@' aclocal | wc -l` -ne 0; then \
489 echo "Unresolved @...@ substitution in aclocal" 1>&2; \
490 exit 1; \
492 @if test `grep -E '^[^#]*@[A-Za-z_0-9]+@' automake | wc -l` -ne 0; then \
493 echo "Unresolved @...@ substitution in automake" 1>&2; \
494 exit 1; \
497 sc_unquoted_DESTDIR:
498 @if grep -E "[^\'\"]\\\$$\(DESTDIR" $(ams); then \
499 echo 'Suspicious unquoted DESTDIR uses.' 1>&2 ; \
500 exit 1; \
503 sc_tabs_in_texi:
504 @if grep ' ' $(srcdir)/doc/automake.texi; then \
505 echo 'Do not use tabs in the manual.' 1>&2; \
506 exit 1; \
509 sc_at_in_texi:
510 @if grep -E '([^@]|^)@([ ][^@]|$$)' $(srcdir)/doc/automake.texi; \
511 then \
512 echo 'Unescaped @.' 1>&2; \
513 exit 1; \
516 $(syntax_check_rules): automake aclocal
517 maintainer-check: $(syntax_check_rules)
518 .PHONY: maintainer-check $(syntax_check_rules)
520 ## Check that the list of tests given in the Makefile is equal to the
521 ## list of all test scripts in the Automake testsuite.
522 maintainer-check: maintainer-check-list-of-tests